Index: protocols/twitter/Makefile
===================================================================
--- protocols/twitter/Makefile	(revision 1b221e0abd6453e3ca9cf45916ff6d16f94eff2b)
+++ protocols/twitter/Makefile	(revision 1b221e0abd6453e3ca9cf45916ff6d16f94eff2b)
@@ -0,0 +1,43 @@
+###########################
+## Makefile for BitlBee  ##
+##                       ##
+## Copyright 2002 Lintux ##
+###########################
+
+### DEFINITIONS
+
+-include ../../Makefile.settings
+
+# [SH] Program variables
+objects = twitter.o twitter_http.o twitter_lib.o
+
+CFLAGS += -Wall
+LFLAGS += -r
+
+# [SH] Phony targets
+all: twitter_mod.o
+check: all
+lcov: check
+gcov: 
+	gcov *.c
+	
+.PHONY: all clean distclean
+
+clean:
+	rm -f *.o core
+
+distclean: clean
+
+### MAIN PROGRAM
+
+$(objects): ../../Makefile.settings Makefile
+
+$(objects): %.o: %.c
+	@echo '*' Compiling $<
+	@$(CC) -c $(CFLAGS) $< -o $@
+
+twitter_mod.o: $(objects)
+	@echo '*' Linking twitter_mod.o
+	@$(LD) $(LFLAGS) $(objects) -o twitter_mod.o
+	
+
Index: protocols/twitter/twitter.c
===================================================================
--- protocols/twitter/twitter.c	(revision 1b221e0abd6453e3ca9cf45916ff6d16f94eff2b)
+++ protocols/twitter/twitter.c	(revision 1b221e0abd6453e3ca9cf45916ff6d16f94eff2b)
@@ -0,0 +1,221 @@
+/***************************************************************************\
+*                                                                           *
+*  BitlBee - An IRC to IM gateway                                           *
+*  Simple module to facilitate twitter functionality.                       *
+*                                                                           *
+*  Copyright 2009 Geert Mulders <g.c.w.m.mulders@gmail.com>                 *
+*                                                                           *
+*  This library is free software; you can redistribute it and/or            *
+*  modify it under the terms of the GNU Lesser General Public               *
+*  License as published by the Free Software Foundation, version            *
+*  2.1.                                                                     *
+*                                                                           *
+*  This library is distributed in the hope that it will be useful,          *
+*  but WITHOUT ANY WARRANTY; without even the implied warranty of           *
+*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU        *
+*  Lesser General Public License for more details.                          *
+*                                                                           *
+*  You should have received a copy of the GNU Lesser General Public License *
+*  along with this library; if not, write to the Free Software Foundation,  *
+*  Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA           *
+*                                                                           *
+****************************************************************************/
+
+#include "nogaim.h"
+#include "twitter.h"
+#include "twitter_http.h"
+#include "twitter_lib.h"
+
+
+/**
+ *  * Main loop function
+ *   */
+gboolean twitter_main_loop(gpointer data, gint fd, b_input_condition cond)
+{
+	struct im_connection *ic = data;
+	// Check if we are still logged in...
+	if ((ic->flags & OPT_LOGGED_IN) != OPT_LOGGED_IN)
+		return 0;
+
+	// Do stuff..
+	twitter_get_home_timeline(ic, -1);
+
+	// If we are still logged in run this function again after timeout.
+	return (ic->flags & OPT_LOGGED_IN) == OPT_LOGGED_IN;
+}
+
+
+static void twitter_init( account_t *acc )
+{
+}
+
+/**
+ * Login method. Since the twitter API works with seperate HTTP request we 
+ * only save the user and pass to the twitter_data object.
+ */
+static void twitter_login( account_t *acc )
+{
+	struct im_connection *ic = imcb_new( acc );
+	struct twitter_data *td = g_new0( struct twitter_data, 1 );
+	
+	td->user = acc->user;
+	td->pass = acc->pass;
+	td->home_timeline_id = 0;
+
+	ic->proto_data = td;
+
+	// Set the status to logged in.
+	ic->flags = OPT_LOGGED_IN;
+
+	// Try to get the buddies...
+	//twitter_get_friends_ids(ic, -1);
+
+	//twitter_get_home_timeline(ic, -1);
+
+	// Run this once. After this queue the main loop function.
+	twitter_main_loop(ic, -1, 0);
+
+	// Queue the main_loop
+	b_timeout_add(60000, twitter_main_loop, ic);
+
+	imcb_log( ic, "Connecting to twitter" );
+	imcb_connected(ic);
+}
+
+/**
+ * Logout method. Just free the twitter_data.
+ */
+static void twitter_logout( struct im_connection *ic )
+{
+	struct twitter_data *td = ic->proto_data;
+	
+	// Set the status to logged out.
+	ic->flags = 0;
+
+	if( td )
+	{
+		g_free( td );
+	}
+}
+
+/**
+ *
+ */
+static int twitter_buddy_msg( struct im_connection *ic, char *who, char *message, int away )
+{
+	imcb_log( ic, "In twitter_buddy_msg...");
+	twitter_post_status(ic, message);
+	return( 0 );
+}
+
+/**
+ *
+ */
+static GList *twitter_away_states( struct im_connection *ic )
+{
+	static GList *l = NULL;
+	return l;
+}
+
+static void twitter_set_away( struct im_connection *ic, char *state, char *message )
+{
+}
+
+static void twitter_set_my_name( struct im_connection *ic, char *info )
+{
+	imcb_log( ic, "In twitter_set_my_name..." );
+//	char * aap = twitter_http("http://gertje.org", NULL, ic, 1, "geert", "poep", NULL, 0);
+
+//	imcb_log( ic, aap );
+//	g_free(aap);
+}
+
+static void twitter_get_info(struct im_connection *ic, char *who) 
+{
+}
+
+static void twitter_add_buddy( struct im_connection *ic, char *who, char *group )
+{
+}
+
+static void twitter_remove_buddy( struct im_connection *ic, char *who, char *group )
+{
+}
+
+static void twitter_chat_msg( struct groupchat *c, char *message, int flags )
+{
+}
+
+static void twitter_chat_invite( struct groupchat *c, char *who, char *message )
+{
+}
+
+static void twitter_chat_leave( struct groupchat *c )
+{
+}
+
+static struct groupchat *twitter_chat_with( struct im_connection *ic, char *who )
+{
+	return NULL;
+}
+
+static void twitter_keepalive( struct im_connection *ic )
+{
+}
+
+static void twitter_add_permit( struct im_connection *ic, char *who )
+{
+}
+
+static void twitter_rem_permit( struct im_connection *ic, char *who )
+{
+}
+
+static void twitter_add_deny( struct im_connection *ic, char *who )
+{
+}
+
+static void twitter_rem_deny( struct im_connection *ic, char *who )
+{
+}
+
+static int twitter_send_typing( struct im_connection *ic, char *who, int typing )
+{
+	return( 1 );
+}
+
+//static char *twitter_set_display_name( set_t *set, char *value )
+//{
+//	return value;
+//}
+
+void twitter_initmodule()
+{
+	struct prpl *ret = g_new0(struct prpl, 1);
+	
+	ret->name = "twitter";
+	ret->login = twitter_login;
+	ret->init = twitter_init;
+	ret->logout = twitter_logout;
+	ret->buddy_msg = twitter_buddy_msg;
+	ret->away_states = twitter_away_states;
+	ret->set_away = twitter_set_away;
+	ret->get_info = twitter_get_info;
+	ret->set_my_name = twitter_set_my_name;
+	ret->add_buddy = twitter_add_buddy;
+	ret->remove_buddy = twitter_remove_buddy;
+	ret->chat_msg = twitter_chat_msg;
+	ret->chat_invite = twitter_chat_invite;
+	ret->chat_leave = twitter_chat_leave;
+	ret->chat_with = twitter_chat_with;
+	ret->keepalive = twitter_keepalive;
+	ret->add_permit = twitter_add_permit;
+	ret->rem_permit = twitter_rem_permit;
+	ret->add_deny = twitter_add_deny;
+	ret->rem_deny = twitter_rem_deny;
+	ret->send_typing = twitter_send_typing;
+	ret->handle_cmp = g_strcasecmp;
+
+	register_protocol(ret);
+}
+
Index: protocols/twitter/twitter.h
===================================================================
--- protocols/twitter/twitter.h	(revision 1b221e0abd6453e3ca9cf45916ff6d16f94eff2b)
+++ protocols/twitter/twitter.h	(revision 1b221e0abd6453e3ca9cf45916ff6d16f94eff2b)
@@ -0,0 +1,42 @@
+/***************************************************************************\
+*                                                                           *
+*  BitlBee - An IRC to IM gateway                                           *
+*  Simple module to facilitate twitter functionality.                       *
+*                                                                           *
+*  Copyright 2009 Geert Mulders <g.c.w.m.mulders@gmail.com>                 *
+*                                                                           *
+*  This library is free software; you can redistribute it and/or            *
+*  modify it under the terms of the GNU Lesser General Public               *
+*  License as published by the Free Software Foundation, version            *
+*  2.1.                                                                     *
+*                                                                           *
+*  This library is distributed in the hope that it will be useful,          *
+*  but WITHOUT ANY WARRANTY; without even the implied warranty of           *
+*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU        *
+*  Lesser General Public License for more details.                          *
+*                                                                           *
+*  You should have received a copy of the GNU Lesser General Public License *
+*  along with this library; if not, write to the Free Software Foundation,  *
+*  Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA           *
+*                                                                           *
+****************************************************************************/
+
+#include "nogaim.h"
+
+#ifndef _TWITTER_H
+#define _TWITTER_H
+
+#ifdef DEBUG_TWITTER
+#define debug( text... ) imcb_log( ic, text );
+#else
+#define debug( text... )
+#endif
+
+struct twitter_data
+{
+	char* user;
+	char* pass;
+	guint64 home_timeline_id;
+};
+
+#endif //_TWITTER_H
Index: protocols/twitter/twitter_http.c
===================================================================
--- protocols/twitter/twitter_http.c	(revision 1b221e0abd6453e3ca9cf45916ff6d16f94eff2b)
+++ protocols/twitter/twitter_http.c	(revision 1b221e0abd6453e3ca9cf45916ff6d16f94eff2b)
@@ -0,0 +1,235 @@
+/***************************************************************************\
+*                                                                           *
+*  BitlBee - An IRC to IM gateway                                           *
+*  Simple module to facilitate twitter functionality.                       *
+*                                                                           *
+*  Copyright 2009 Geert Mulders <g.c.w.m.mulders@gmail.com>                 *
+*                                                                           *
+*  This library is free software; you can redistribute it and/or            *
+*  modify it under the terms of the GNU Lesser General Public               *
+*  License as published by the Free Software Foundation, version            *
+*  2.1.                                                                     *
+*                                                                           *
+*  This library is distributed in the hope that it will be useful,          *
+*  but WITHOUT ANY WARRANTY; without even the implied warranty of           *
+*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU        *
+*  Lesser General Public License for more details.                          *
+*                                                                           *
+*  You should have received a copy of the GNU Lesser General Public License *
+*  along with this library; if not, write to the Free Software Foundation,  *
+*  Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA           *
+*                                                                           *
+****************************************************************************/
+
+/***************************************************************************\
+*                                                                           *
+*  Some funtions within this file have been copied from other files within  *
+*  BitlBee.                                                                 *
+*                                                                           *
+****************************************************************************/ 
+
+#include "twitter_http.h"
+#include "twitter.h"
+#include "bitlbee.h"
+#include "url.h"
+#include "misc.h"
+#include "base64.h"
+#include <ctype.h>
+#include <errno.h>
+
+
+char *twitter_urlencode(const char *instr);
+char *twitter_url_append(char *url, char *key, char* value);
+static int isurlchar(unsigned char c);
+
+/**
+ * Do a request.
+ * This is actually pretty generic function... Perhaps it should move to the lib/http_client.c
+ */
+void *twitter_http(char *url_string, http_input_function func, gpointer data, int is_post, char* user, char* pass, char** arguments, int arguments_len)
+{
+	url_t *url = g_new0( url_t, 1 );
+	char *tmp;
+	char *request;
+	void *ret;
+	char *userpass = NULL;
+	char *userpass_base64;
+	char *url_arguments;
+
+	// Fill the url structure.
+	if( !url_set( url, url_string ) )
+	{
+		g_free( url );
+		return NULL;
+	}
+
+	if( url->proto != PROTO_HTTP && url->proto != PROTO_HTTPS )
+	{
+		g_free( url );
+		return NULL;
+	}
+
+	// Concatenate user and pass
+	if (user && pass) {
+		userpass = g_strdup_printf("%s:%s", user, pass);
+		userpass_base64 = base64_encode((unsigned char*)userpass, strlen(userpass));
+	} else {
+		userpass_base64 = NULL;
+	}
+
+	url_arguments = g_malloc(1);
+	url_arguments[0] = '\0';
+
+	// Construct the url arguments.
+	if (arguments_len != 0)
+	{
+		int i;
+		for (i=0; i<arguments_len; i+=2) 
+		{
+			tmp = twitter_url_append(url_arguments, arguments[i], arguments[i+1]);
+			g_free(url_arguments);
+			url_arguments = tmp;
+		}
+	}
+
+	// Do GET stuff...
+	if (!is_post)
+	{
+		// Find the char-pointer of the end of the string.
+		tmp = url->file + strlen(url->file);
+		tmp[0] = '?';
+		// append the url_arguments to the end of the url->file.
+		// TODO GM: Check the length?
+		g_stpcpy (tmp+1, url_arguments);
+	}
+
+
+	// Make the request.
+	request = g_strdup_printf(  "%s %s HTTP/1.0\r\n"
+								"Host: %s\r\n"
+								"User-Agent: BitlBee " BITLBEE_VERSION " " ARCH "/" CPU "\r\n",
+								is_post ? "POST" : "GET", url->file, url->host );
+
+	// If a pass and user are given we append them to the request.
+	if (userpass_base64)
+	{
+		tmp = g_strdup_printf("%sAuthorization: Basic %s\r\n", request, userpass_base64);
+		g_free(request);
+		request = tmp;
+	}
+
+	// Do POST stuff..
+	if (is_post)
+	{
+		// Append the Content-Type and url-encoded arguments.
+		tmp = g_strdup_printf("%sContent-Type: application/x-www-form-urlencoded\r\nContent-Length: %i\r\n\r\n%s", 
+								request, strlen(url_arguments), url_arguments);
+		g_free(request);
+		request = tmp;
+	} else {
+		// Append an extra \r\n to end the request...
+		tmp = g_strdup_printf("%s\r\n", request);
+		g_free(request);
+		request = tmp;
+	}
+
+	ret = http_dorequest( url->host, url->port,	url->proto == PROTO_HTTPS, request, func, data );
+
+	g_free( url );
+	g_free( userpass );
+	g_free( userpass_base64 );
+	g_free( url_arguments );
+	g_free( request );
+	return ret;
+}
+
+char *twitter_url_append(char *url, char *key, char* value)
+{
+	char *key_encoded = twitter_urlencode(key);
+	char *value_encoded = twitter_urlencode(value);
+	char *retval;
+	if (strlen(url) != 0)
+		retval = g_strdup_printf("%s&%s=%s", url, key_encoded, value_encoded);
+	else
+		retval = g_strdup_printf("%s=%s", key_encoded, value_encoded);
+
+	g_free(key_encoded);
+	g_free(value_encoded);
+
+	return retval;
+}
+
+char *twitter_urlencode(const char *instr)
+{
+	int ipos=0, bpos=0;
+	char *str = NULL;
+	int len = strlen(instr);
+
+	if(!(str = g_new(char, 3*len + 1) ))
+		return "";
+
+	while(instr[ipos]) {
+		while(isurlchar(instr[ipos]))
+			str[bpos++] = instr[ipos++];
+		if(!instr[ipos])
+			break;
+
+		g_snprintf(&str[bpos], 4, "%%%.2x", instr[ipos]);
+		bpos+=3;
+		ipos++;
+	}
+	str[bpos]='\0';
+
+	/* free extra alloc'ed mem. */
+	len = strlen(str);
+	str = g_renew(char, str, len+1);
+
+	return (str);
+}
+
+
+char *twitter_urldecode(const char *instr)
+{
+	int ipos=0, bpos=0;
+	char *str = NULL;
+	char entity[3]={0,0,0};
+	unsigned dec;
+	int len = strlen(instr);
+
+	if(!(str = g_new(char, len+1) ))
+		return "";
+
+	while(instr[ipos]) {
+		while(instr[ipos] && instr[ipos]!='%')
+			if(instr[ipos]=='+') {
+				str[bpos++]=' ';
+				ipos++;
+			} else
+				str[bpos++] = instr[ipos++];
+			if(!instr[ipos])
+				break;
+
+			if(instr[ipos+1] && instr[ipos+2]) {
+				ipos++;
+				entity[0]=instr[ipos++];
+				entity[1]=instr[ipos++];
+				sscanf(entity, "%2x", &dec);
+				str[bpos++] = (char)dec;
+			} else {
+				str[bpos++] = instr[ipos++];
+			}
+		}
+	str[bpos]='\0';
+
+	/* free extra alloc'ed mem. */
+	len = strlen(str);
+	str = g_renew(char, str, len+1);
+
+	return (str);
+}
+
+static int isurlchar(unsigned char c)
+{
+	return (isalnum(c) || '-' == c || '_' == c);
+}
+
Index: protocols/twitter/twitter_http.h
===================================================================
--- protocols/twitter/twitter_http.h	(revision 1b221e0abd6453e3ca9cf45916ff6d16f94eff2b)
+++ protocols/twitter/twitter_http.h	(revision 1b221e0abd6453e3ca9cf45916ff6d16f94eff2b)
@@ -0,0 +1,34 @@
+/***************************************************************************\
+*                                                                           *
+*  BitlBee - An IRC to IM gateway                                           *
+*  Simple module to facilitate twitter functionality.                       *
+*                                                                           *
+*  Copyright 2009 Geert Mulders <g.c.w.m.mulders@gmail.com>                 *
+*                                                                           *
+*  This library is free software; you can redistribute it and/or            *
+*  modify it under the terms of the GNU Lesser General Public               *
+*  License as published by the Free Software Foundation, version            *
+*  2.1.                                                                     *
+*                                                                           *
+*  This library is distributed in the hope that it will be useful,          *
+*  but WITHOUT ANY WARRANTY; without even the implied warranty of           *
+*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU        *
+*  Lesser General Public License for more details.                          *
+*                                                                           *
+*  You should have received a copy of the GNU Lesser General Public License *
+*  along with this library; if not, write to the Free Software Foundation,  *
+*  Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA           *
+*                                                                           *
+****************************************************************************/
+
+#ifndef _TWITTER_HTTP_H
+#define _TWITTER_HTTP_H
+
+#include "nogaim.h"
+#include "http_client.h"
+
+void *twitter_http(char *url_string, http_input_function func, gpointer data, int is_post, 
+					char* user, char* pass, char** arguments, int arguments_len);
+
+#endif //_TWITTER_HTTP_H
+
Index: protocols/twitter/twitter_lib.c
===================================================================
--- protocols/twitter/twitter_lib.c	(revision 1b221e0abd6453e3ca9cf45916ff6d16f94eff2b)
+++ protocols/twitter/twitter_lib.c	(revision 1b221e0abd6453e3ca9cf45916ff6d16f94eff2b)
@@ -0,0 +1,374 @@
+/***************************************************************************\
+*                                                                           *
+*  BitlBee - An IRC to IM gateway                                           *
+*  Simple module to facilitate twitter functionality.                       *
+*                                                                           *
+*  Copyright 2009 Geert Mulders <g.c.w.m.mulders@gmail.com>                 *
+*                                                                           *
+*  This library is free software; you can redistribute it and/or            *
+*  modify it under the terms of the GNU Lesser General Public               *
+*  License as published by the Free Software Foundation, version            *
+*  2.1.                                                                     *
+*                                                                           *
+*  This library is distributed in the hope that it will be useful,          *
+*  but WITHOUT ANY WARRANTY; without even the implied warranty of           *
+*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU        *
+*  Lesser General Public License for more details.                          *
+*                                                                           *
+*  You should have received a copy of the GNU Lesser General Public License *
+*  along with this library; if not, write to the Free Software Foundation,  *
+*  Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA           *
+*                                                                           *
+****************************************************************************/
+
+#include "twitter_http.h"
+#include "twitter.h"
+#include "bitlbee.h"
+#include "url.h"
+#include "misc.h"
+#include "base64.h"
+#include "xmltree.h"
+#include "twitter_lib.h"
+#include <ctype.h>
+#include <errno.h>
+
+#define TXL_STATUS 1
+#define TXL_ID 1
+
+struct twitter_xml_list {
+	int next_cursor;
+	GSList *list;
+	gpointer data;
+};
+
+struct twitter_xml_user {
+	char *name;
+	char *screen_name;
+};
+
+struct twitter_xml_status {
+	char *created_at;
+	char *text;
+	struct twitter_xml_user *user;
+	guint64 id;
+};
+
+void txl_free(struct twitter_xml_list *txl, int type);
+void txs_free(struct twitter_xml_status *txs);
+void txu_free(struct twitter_xml_user *txu);
+
+static void twitter_http_get_friends_ids(struct http_request *req);
+
+/**
+ * Get the friends ids.
+ */
+void twitter_get_friends_ids(struct im_connection *ic, int next_cursor)
+{
+	struct twitter_data *td = ic->proto_data;
+
+	// Primitive, but hey! It works...	
+	char* args[2];
+	args[0] = "cursor";
+	args[1] = g_strdup_printf ("%d", next_cursor);
+	twitter_http(TWITTER_FRIENDS_IDS_URL, twitter_http_get_friends_ids, ic, 0, td->user, td->pass, args, 2);
+
+	g_free(args[1]);
+}
+
+/**
+ * Function to help fill a list.
+ */
+static xt_status twitter_xt_next_cursor( struct xt_node *node, struct twitter_xml_list *txl )
+{
+	// Do something with the cursor.
+	txl->next_cursor = atoi(node->text);
+
+	return XT_HANDLED;
+}
+
+/**
+ * Fill a list of ids.
+ */
+static xt_status twitter_xt_get_friends_id_list( struct xt_node *node, struct twitter_xml_list *txl )
+{
+	struct xt_node *child;
+
+	// The root <statuses> node should hold the list of statuses <status>
+	// Walk over the nodes children.
+	for( child = node->children ; child ; child = child->next )
+	{
+		if ( g_strcasecmp( "id", child->name ) == 0)
+		{
+			// Add the item to the list.
+			txl->list = g_slist_append (txl->list, g_memdup( node->text, node->text_len + 1 ));
+		}
+		else if ( g_strcasecmp( "next_cursor", child->name ) == 0)
+		{
+			twitter_xt_next_cursor(child, txl);
+		}
+	}
+
+	return XT_HANDLED;
+}
+
+/**
+ * Callback for getting the friends ids.
+ */
+static void twitter_http_get_friends_ids(struct http_request *req)
+{
+	struct im_connection *ic;
+	struct xt_parser *parser;
+	struct twitter_xml_list *txl;
+
+	ic = req->data;
+
+	// Check if the HTTP request went well.
+	if (req->status_code != 200) {
+		// It didn't go well, output the error and return.
+		imcb_error(ic, "Could not retrieve friends. HTTP STATUS: %d", req->status_code);
+		return;
+	}
+
+	txl = g_new0(struct twitter_xml_list, 1);
+	txl->list = NULL;
+
+	// Parse the data.
+	parser = xt_new( NULL, txl );
+	xt_feed( parser, req->reply_body, req->body_size );
+	twitter_xt_get_friends_id_list(parser->root, txl);
+	xt_free( parser );
+
+	if (txl->next_cursor)
+		twitter_get_friends_ids(ic, txl->next_cursor);
+
+	txl_free(txl, TXL_ID);
+	g_free(txl);
+}
+
+/**
+ * Function to fill a twitter_xml_user struct.
+ * It sets:
+ *  - the name and
+ *  - the screen_name.
+ */
+static xt_status twitter_xt_get_user( struct xt_node *node, struct twitter_xml_user *txu )
+{
+	struct xt_node *child;
+
+	// Walk over the nodes children.
+	for( child = node->children ; child ; child = child->next )
+	{
+		if ( g_strcasecmp( "name", child->name ) == 0)
+		{
+			txu->name = g_memdup( child->text, child->text_len + 1 );
+		}
+		else if (g_strcasecmp( "screen_name", child->name ) == 0)
+		{
+			txu->screen_name = g_memdup( child->text, child->text_len + 1 );
+		}
+	}
+	return XT_HANDLED;
+}
+
+/**
+ * Function to fill a twitter_xml_status struct.
+ * It sets:
+ *  - the status text and
+ *  - the created_at timestamp and
+ *  - the status id and
+ *  - the user in a twitter_xml_user struct.
+ */
+static xt_status twitter_xt_get_status( struct xt_node *node, struct twitter_xml_status *txs )
+{
+	struct xt_node *child;
+
+	// Walk over the nodes children.
+	for( child = node->children ; child ; child = child->next )
+	{
+		if ( g_strcasecmp( "text", child->name ) == 0)
+		{
+			txs->text = g_memdup( child->text, child->text_len + 1 );
+		}
+		else if (g_strcasecmp( "created_at", child->name ) == 0)
+		{
+			txs->created_at = g_memdup( child->text, child->text_len + 1 );
+		}
+		else if (g_strcasecmp( "user", child->name ) == 0)
+		{
+			txs->user = g_new0(struct twitter_xml_user, 1);
+			twitter_xt_get_user( child, txs->user );
+		}
+		else if (g_strcasecmp( "id", child->name ) == 0)
+		{
+			txs->id = g_ascii_strtoull (child->text, NULL, 10);
+		}
+	}
+	return XT_HANDLED;
+}
+
+/**
+ * Function to fill a twitter_xml_list struct.
+ * It sets:
+ *  - all <status>es within the <status> element and
+ *  - the next_cursor.
+ */
+static xt_status twitter_xt_get_status_list( struct xt_node *node, struct twitter_xml_list *txl )
+{
+	struct twitter_xml_status *txs;
+	struct xt_node *child;
+
+	// The root <statuses> node should hold the list of statuses <status>
+	// Walk over the nodes children.
+	for( child = node->children ; child ; child = child->next )
+	{
+		if ( g_strcasecmp( "status", child->name ) == 0)
+		{
+			txs = g_new0(struct twitter_xml_status, 1);
+			twitter_xt_get_status(child, txs);
+			// Put the item in the front of the list.
+			txl->list = g_slist_prepend (txl->list, txs);
+		}
+		else if ( g_strcasecmp( "next_cursor", child->name ) == 0)
+		{
+			twitter_xt_next_cursor(child, txl);
+		}
+	}
+
+	return XT_HANDLED;
+}
+
+static void twitter_http_get_home_timeline(struct http_request *req);
+
+/**
+ * Get the timeline.
+ */
+void twitter_get_home_timeline(struct im_connection *ic, int next_cursor)
+{
+	struct twitter_data *td = ic->proto_data;
+
+	char* args[4];
+	args[0] = "cursor";
+	args[1] = g_strdup_printf ("%d", next_cursor);
+	if (td->home_timeline_id) {
+		args[2] = "since_id";
+		args[3] = g_strdup_printf ("%llu", td->home_timeline_id);
+	}
+
+	twitter_http(TWITTER_HOME_TIMELINE_URL, twitter_http_get_home_timeline, ic, 0, td->user, td->pass, args, td->home_timeline_id ? 4 : 2);
+
+	g_free(args[1]);
+	if (td->home_timeline_id) {
+		g_free(args[3]);
+	}
+}
+
+/**
+ * Callback for getting the home timeline.
+ */
+static void twitter_http_get_home_timeline(struct http_request *req)
+{
+	struct im_connection *ic = req->data;;
+	struct xt_parser *parser;
+	struct twitter_xml_list *txl;
+	struct twitter_data *td = ic->proto_data;
+
+	// Check if the HTTP request went well.
+	if (req->status_code != 200) {
+		// It didn't go well, output the error and return.
+		imcb_error(ic, "Could not retrieve home/timeline. HTTP STATUS: %d", req->status_code);
+		return;
+	}
+
+	txl = g_new0(struct twitter_xml_list, 1);
+	txl->list = NULL;
+	
+	// Parse the data.
+	parser = xt_new( NULL, txl );
+	xt_feed( parser, req->reply_body, req->body_size );
+	// The root <statuses> node should hold the list of statuses <status>
+	twitter_xt_get_status_list(parser->root, txl);
+	xt_free( parser );
+	
+	GSList *l;
+	struct twitter_xml_status *status;
+
+	imcb_add_buddy( ic, "home_timeline", NULL );
+	imcb_buddy_status( ic, "home_timeline", OPT_LOGGED_IN, NULL, NULL );
+
+	for ( l = txl->list; l ; l = g_slist_next(l) )
+	{
+		status = l->data;
+		imcb_buddy_msg( ic, "home_timeline", status->text, 0, 0 );
+		td->home_timeline_id = td->home_timeline_id < status->id ? status->id : td->home_timeline_id;
+	}
+
+	// Free the structure.	
+	txl_free(txl, TXL_STATUS);
+	g_free(txl);
+}
+
+/**
+ * Free a twitter_xml_list struct.
+ * type is the type of list the struct holds.
+ */
+void txl_free(struct twitter_xml_list *txl, int type)
+{
+	GSList *l;
+	for ( l = txl->list; l ; l = g_slist_next(l) )
+		if (type == TXL_STATUS)
+			txs_free((struct twitter_xml_status *)l->data);
+		else if (type == TXL_ID)
+			g_free(l->data);
+	g_slist_free(txl->list);
+}
+
+/**
+ * Frees a twitter_xml_status struct.
+ */
+void txs_free(struct twitter_xml_status *txs)
+{
+	g_free(txs->created_at);
+	g_free(txs->text);
+	txu_free(txs->user);
+}
+
+/**
+ * Frees a twitter_xml_user struct.
+ */
+void txu_free(struct twitter_xml_user *txu)
+{
+	g_free(txu->name);
+	g_free(txu->screen_name);
+}
+
+/**
+ * Callback after sending a new update to twitter.
+ */
+static void twitter_http_post_status(struct http_request *req)
+{
+	struct im_connection *ic = req->data;
+
+	// Check if the HTTP request went well.
+	if (req->status_code != 200) {
+		// It didn't go well, output the error and return.
+		imcb_error(ic, "Could not post tweed... HTTP STATUS: %d", req->status_code);
+		imcb_error(ic, req->reply_body);
+		return;
+	}
+}
+
+/**
+ * Function to POST a new status to twitter.
+ */ 
+void twitter_post_status(struct im_connection *ic, char* msg)
+{
+	struct twitter_data *td = ic->proto_data;
+
+	char* args[2];
+	args[0] = "status";
+	args[1] = msg;
+	twitter_http(TWITTER_STATUS_UPDATE_URL, twitter_http_post_status, ic, 1, td->user, td->pass, args, 2);
+	g_free(args[1]);
+}
+
+
Index: protocols/twitter/twitter_lib.h
===================================================================
--- protocols/twitter/twitter_lib.h	(revision 1b221e0abd6453e3ca9cf45916ff6d16f94eff2b)
+++ protocols/twitter/twitter_lib.h	(revision 1b221e0abd6453e3ca9cf45916ff6d16f94eff2b)
@@ -0,0 +1,84 @@
+/***************************************************************************\
+*                                                                           *
+*  BitlBee - An IRC to IM gateway                                           *
+*  Simple module to facilitate twitter functionality.                       *
+*                                                                           *
+*  Copyright 2009 Geert Mulders <g.c.w.m.mulders@gmail.com>                 *
+*                                                                           *
+*  This library is free software; you can redistribute it and/or            *
+*  modify it under the terms of the GNU Lesser General Public               *
+*  License as published by the Free Software Foundation, version            *
+*  2.1.                                                                     *
+*                                                                           *
+*  This library is distributed in the hope that it will be useful,          *
+*  but WITHOUT ANY WARRANTY; without even the implied warranty of           *
+*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU        *
+*  Lesser General Public License for more details.                          *
+*                                                                           *
+*  You should have received a copy of the GNU Lesser General Public License *
+*  along with this library; if not, write to the Free Software Foundation,  *
+*  Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA           *
+*                                                                           *
+****************************************************************************/
+
+
+#ifndef _TWITTER_LIB_H
+#define _TWITTER_LIB_H
+
+#include "nogaim.h"
+#include "twitter_http.h"
+
+#define TWITTER_API_URL "http://twitter.com"
+
+/* Status URLs */
+#define TWITTER_STATUS_UPDATE_URL TWITTER_API_URL "/statuses/update.xml"
+#define TWITTER_STATUS_SHOW_URL TWITTER_API_URL "/statuses/show/"
+#define TWITTER_STATUS_DESTROY_URL TWITTER_API_URL "/statuses/destroy/"
+
+/* Timeline URLs */
+#define TWITTER_PUBLIC_TIMELINE_URL TWITTER_API_URL "/statuses/public_timeline.xml"
+#define TWITTER_FEATURED_USERS_URL TWITTER_API_URL "/statuses/featured.xml"
+#define TWITTER_FRIENDS_TIMELINE_URL TWITTER_API_URL "/statuses/friends_timeline.xml"
+#define TWITTER_HOME_TIMELINE_URL TWITTER_API_URL "/statuses/home_timeline.xml"
+#define TWITTER_MENTIONS_URL TWITTER_API_URL "/statuses/mentions.xml"
+#define TWITTER_USER_TIMELINE_URL TWITTER_API_URL "/statuses/user_timeline.xml"
+
+/* Users URLs */
+#define TWITTER_SHOW_USERS_URL TWITTER_API_URL "/users/show.xml"
+#define TWITTER_SHOW_FRIENDS_URL TWITTER_API_URL "/statuses/friends.xml"
+#define TWITTER_SHOW_FOLLOWERS_URL TWITTER_API_URL "/statuses/followers.xml"
+
+/* Direct messages URLs */
+#define TWITTER_DIRECT_MESSAGES_URL TWITTER_API_URL "/direct_messages.xml"
+#define TWITTER_DIRECT_MESSAGENEW_URL TWITTER_API_URL "/direct_messages/new.xml"
+#define TWITTER_DIRECT_MESSAGESSENT_URL TWITTER_API_URL "/direct_messages/sent.xml"
+#define TWITTER_DIRECT_MESSAGEDESTROY_URL TWITTER_API_URL "/direct_messages/destroy/"
+
+/* Friendships URLs */
+#define TWITTER_FRIENDSHIPS_CREATE_URL TWITTER_API_URL "/friendships/create.xml"
+#define TWITTER_FRIENDSHIPS_DESTROY_URL TWITTER_API_URL "/friendships/destroy.xml"
+#define TWITTER_FRIENDSHIPS_SHOW_URL TWITTER_API_URL "/friendships/show.xml"
+
+/* Social graphs URLs */
+#define TWITTER_FRIENDS_IDS_URL TWITTER_API_URL "/friends/ids.xml"
+#define TWITTER_FOLLOWERS_IDS_URL TWITTER_API_URL "/followers/ids.xml"
+
+/* Account URLs */
+#define TWITTER_ACCOUNT_RATE_LIMIT_URL TWITTER_API_URL "/account/rate_limit_status.xml"
+
+/* Favorites URLs */
+#define TWITTER_FAVORITES_GET_URL TWITTER_API_URL "/favorites.xml"
+#define TWITTER_FAVORITE_CREATE_URL TWITTER_API_URL "/favorites/create/"
+#define TWITTER_FAVORITE_DESTROY_URL TWITTER_API_URL "/favorites/destroy/"
+
+/* Block URLs */
+#define TWITTER_BLOCKS_CREATE_URL TWITTER_API_URL "/blocks/create/"
+#define TWITTER_BLOCKS_DESTROY_URL TWITTER_API_URL "/blocks/destroy/"
+
+void twitter_get_friends_ids(struct im_connection *ic, int next_cursor);
+void twitter_get_home_timeline(struct im_connection *ic, int next_cursor);
+
+void twitter_post_status(struct im_connection *ic, char* msg);
+
+#endif //_TWITTER_LIB_H
+
